property debug_me : false

property script_author : "Jonathan Nathan"
property script_name : "Stop_Loop"
property script_version : "1.0.1"
property script_release_date : "January 31, 2007"
property script_copyright : " 2003, 2007 Jonathan Nathan. All Rights Reserved."

property stop_progress : false

on will finish launching the_object
	set object_name to name of the_object as Unicode text
	my update_status("will finish launching " & object_name)
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as Unicode text))
	activate
	show window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as Unicode text
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		
	else if object_name = "about" then
		tell the_object
			center
			set contents of text field "title" to (script_name & " v" & script_version)
			set contents of text field "author" to ("by " & script_author)
			set contents of text field "release" to ("Released " & script_release_date)
			set contents of text field "copyright" to (script_copyright)
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as Unicode text
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as Unicode text
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		display window "about" attached to window "main"
		
	else if object_name = "quit" then
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as Unicode text
	my update_status("clicked " & object_name)
	
	if object_name = "dialog_ok" then
		set the_win to name of window of the_object
		close panel window the_win
		
	else if object_name = "stop_progress" then
		set my stop_progress to false
		
	else if object_name = "stop_progress_2" then --the offscreen button that has a keyboard equivalent of just "z"
		set my stop_progress to false
		
	else if object_name = "show_progress" then
		my progress_show("Progress Title", "Preparing to do something...")
		--the Stop button isn't checked until the loop starts
		delay 2
		repeat with i from 1 to 10
			if stop_progress = false then
				my progress_hide()
				return
			end if
			my progress_update(i, 10, "Doing Something (Try the Stop button.)", "Working on " & (i as Unicode text) & " of " & (10 as Unicode text) & "...")
			delay 1
		end repeat
		my progress_hide()
		
	end if
end clicked

on progress_show(super_message, the_message)
	set stop_progress to true
	tell window "progress"
		set indeterminate of progress indicator "progress" to true
		set uses threaded animation of progress indicator "progress" to true
		tell progress indicator "progress" to start
		set contents of text field "progress_label_super" to super_message
		set contents of text field "progress_label" to the_message
		update
	end tell
	if visible of window "progress" = false then display window "progress" attached to window "main"
end progress_show

on progress_update(iteration, total_count, super_message, the_message)
	tell window "progress"
		if iteration = 1 then
			tell progress indicator "progress" to stop
			set indeterminate of progress indicator "progress" to false
		end if
		set contents of text field "progress_label_super" to super_message
		set contents of text field "progress_label" to the_message
		set maximum value of progress indicator "progress" to total_count
		set content of progress indicator "progress" to iteration
		update
	end tell
end progress_update

on progress_hide()
	close panel window "progress"
	tell window "progress"
		set contents of text field "progress_label_super" to ""
		set contents of text field "progress_label" to ""
		set content of progress indicator "progress" to 0
		tell progress indicator "progress" to stop
		set indeterminate of progress indicator "progress" to false
		update
	end tell
end progress_hide

on update_status(the_message)
	if debug_me then log the_message
end update_status